<html>
<head>
<title>OgreString.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreString.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreString_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _String_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _String_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// If we&#39;re using the GCC 3.1 C++ Std lib</span>
<a name="l00034"></a>00034 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_GNUC &amp;&amp; OGRE_COMP_VER &gt;= 310 &amp;&amp; !defined(STLPORT)</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00036"></a>00036 <span class="comment">// For gcc 4.3 see http://gcc.gnu.org/gcc-4.3/changes.html</span>
<a name="l00037"></a>00037 <span class="preprocessor">#   if OGRE_COMP_VER &gt;= 430</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#       include &lt;tr1/unordered_map&gt;</span> 
<a name="l00039"></a>00039 <span class="preprocessor">#   else</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#       include &lt;ext/hash_map&gt;</span>
<a name="l00041"></a>00041 <span class="keyword">namespace </span>__gnu_cxx
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043     <span class="keyword">template</span> &lt;&gt; <span class="keyword">struct </span>hash&lt; Ogre::<a class="code" href="namespaceOgre.html#a6190e7c0a19190277aeadf25f536ac8c">_StringBase</a> &gt;
<a name="l00044"></a>00044     {
<a name="l00045"></a>00045         <span class="keywordtype">size_t</span> operator()( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#a6190e7c0a19190277aeadf25f536ac8c">Ogre::_StringBase</a> _stringBase )<span class="keyword"> const</span>
<a name="l00046"></a>00046 <span class="keyword">        </span>{
<a name="l00047"></a>00047             <span class="comment">/* This is the PRO-STL way, but it seems to cause problems with VC7.1</span>
<a name="l00048"></a>00048 <span class="comment">               and in some other cases (although I can&#39;t recreate it)</span>
<a name="l00049"></a>00049 <span class="comment">            hash&lt;const char*&gt; H;</span>
<a name="l00050"></a>00050 <span class="comment">            return H(_stringBase.c_str());</span>
<a name="l00051"></a>00051 <span class="comment">            */</span>
<a name="l00053"></a>00053             <span class="keyword">register</span> <span class="keywordtype">size_t</span> ret = 0;
<a name="l00054"></a>00054             <span class="keywordflow">for</span>( Ogre::_StringBase::const_iterator it = _stringBase.begin(); it != _stringBase.end(); ++it )
<a name="l00055"></a>00055                 ret = 5 * ret + *it;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057             <span class="keywordflow">return</span> ret;
<a name="l00058"></a>00058         }
<a name="l00059"></a>00059     };
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 <span class="preprocessor">#   endif</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>
<a name="l00063"></a>00063 <span class="preprocessor">#endif</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065 <span class="keyword">namespace </span>Ogre {
<a name="l00074"></a><a class="code" href="classOgre_1_1StringUtil.html">00074</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1StringUtil.html" title="Utility class for manipulating Strings.">StringUtil</a>
<a name="l00075"></a>00075     {
<a name="l00076"></a>00076     <span class="keyword">public</span>:
<a name="l00077"></a><a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">00077</a>         <span class="keyword">typedef</span> <a class="code" href="namespaceOgre.html#a9f14407f349c1ec70ddab871a7806590">StringStream</a> <a class="code" href="classOgre_1_1StringUtil.html#a665d79932d54b48b83acff563de7a9e5">StrStreamType</a>;
<a name="l00078"></a>00078 
<a name="l00086"></a>00086         <span class="keyword">static</span> <span class="keywordtype">void</span> trim( <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keywordtype">bool</span> left = <span class="keyword">true</span>, <span class="keywordtype">bool</span> right = <span class="keyword">true</span> );
<a name="l00087"></a>00087 
<a name="l00098"></a>00098         <span class="keyword">static</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;String&gt;::type</a> split( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; delims = <span class="stringliteral">&quot;\t\n &quot;</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxSplits = 0, <span class="keywordtype">bool</span> preserveDelims = <span class="keyword">false</span>);
<a name="l00099"></a>00099 
<a name="l00112"></a>00112         <span class="keyword">static</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;String&gt;::type</a> tokenise( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; delims = <span class="stringliteral">&quot;\t\n &quot;</span>, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; doubleDelims = <span class="stringliteral">&quot;\&quot;&quot;</span>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxSplits = 0);
<a name="l00113"></a>00113 
<a name="l00116"></a>00116         <span class="keyword">static</span> <span class="keywordtype">void</span> toLowerCase( <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str );
<a name="l00117"></a>00117 
<a name="l00120"></a>00120         <span class="keyword">static</span> <span class="keywordtype">void</span> toUpperCase( <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str );
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00128"></a>00128         <span class="keyword">static</span> <span class="keywordtype">bool</span> startsWith(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> lowerCase = <span class="keyword">true</span>);
<a name="l00129"></a>00129 
<a name="l00135"></a>00135         <span class="keyword">static</span> <span class="keywordtype">bool</span> endsWith(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> lowerCase = <span class="keyword">true</span>);
<a name="l00136"></a>00136 
<a name="l00139"></a>00139         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> standardisePath( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;init);
<a name="l00151"></a>00151        <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> normalizeFilePath(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; init, <span class="keywordtype">bool</span> makeLowerCase = <span class="keyword">true</span>);
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00159"></a>00159         <span class="keyword">static</span> <span class="keywordtype">void</span> splitFilename(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; qualifiedName,
<a name="l00160"></a>00160             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; outBasename, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; outPath);
<a name="l00161"></a>00161 
<a name="l00167"></a>00167         <span class="keyword">static</span> <span class="keywordtype">void</span> splitFullFilename(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; qualifiedName, 
<a name="l00168"></a>00168             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outBasename, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outExtention, 
<a name="l00169"></a>00169             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outPath);
<a name="l00170"></a>00170 
<a name="l00174"></a>00174         <span class="keyword">static</span> <span class="keywordtype">void</span> splitBaseFilename(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; fullName, 
<a name="l00175"></a>00175             <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outBasename, <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">Ogre::String</a>&amp; outExtention);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00183"></a>00183         <span class="keyword">static</span> <span class="keywordtype">bool</span> match(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; pattern, <span class="keywordtype">bool</span> caseSensitive = <span class="keyword">true</span>);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00192"></a>00192         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> replaceAll(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; source, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; replaceWhat, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; replaceWithWhat);
<a name="l00193"></a>00193 
<a name="l00195"></a><a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da">00195</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1StringUtil.html#ad2ead745c8c6f4f7056270e22f29e4da" title="Constant blank string, useful for returning by ref where local does not exist.">BLANK</a>;
<a name="l00196"></a>00196     };
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="preprocessor">#if OGRE_COMPILER == OGRE_COMPILER_GNUC &amp;&amp; OGRE_COMP_VER &gt;= 310 &amp;&amp; !defined(STLPORT)</span>
<a name="l00200"></a>00200 <span class="preprocessor"></span><span class="preprocessor">#   if OGRE_COMP_VER &lt; 430</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>    typedef ::__gnu_cxx::hash&lt; _StringBase &gt; <a class="code" href="group__General.html#ga4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00202"></a>00202 <span class="preprocessor">#   else</span>
<a name="l00203"></a>00203 <span class="preprocessor"></span>    typedef ::std::tr1::hash&lt; _StringBase &gt; <a class="code" href="group__General.html#ga4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00204"></a>00204 <span class="preprocessor">#   endif</span>
<a name="l00205"></a>00205 <span class="preprocessor"></span><span class="preprocessor">#elif OGRE_COMPILER == OGRE_COMPILER_CLANG</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span><span class="preprocessor">#   if defined(_LIBCPP_VERSION)</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>    typedef ::std::hash&lt; _StringBase &gt; <a class="code" href="group__General.html#ga4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00208"></a>00208 <span class="preprocessor">#   else</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>    typedef ::std::tr1::hash&lt; _StringBase &gt; <a class="code" href="group__General.html#ga4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00210"></a>00210 <span class="preprocessor">#   endif</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span><span class="preprocessor">#elif OGRE_COMPILER == OGRE_COMPILER_MSVC &amp;&amp; OGRE_COMP_VER &gt;= 1600 &amp;&amp; !defined(STLPORT) // VC++ 10.0</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>    typedef ::std::tr1::hash&lt; _StringBase &gt; <a class="code" href="group__General.html#ga4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00213"></a>00213 <span class="preprocessor">#elif !defined( _STLP_HASH_FUN_H )</span>
<a name="l00214"></a><a class="code" href="group__General.html#ga4adaf30a5217767650a9e0b0b4de540c">00214</a> <span class="preprocessor"></span>    <span class="keyword">typedef</span> stdext::hash_compare&lt; _StringBase, std::less&lt; _StringBase &gt; &gt; <a class="code" href="group__General.html#ga4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00215"></a>00215 <span class="preprocessor">#else</span>
<a name="l00216"></a>00216 <span class="preprocessor"></span>    <span class="keyword">typedef</span> std::hash&lt; _StringBase &gt; <a class="code" href="group__General.html#ga4adaf30a5217767650a9e0b0b4de540c">_StringHash</a>;
<a name="l00217"></a>00217 <span class="preprocessor">#endif </span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>
<a name="l00221"></a>00221 } <span class="comment">// namespace Ogre</span>
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="preprocessor">#endif // _String_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
